module("door", package.seeall);
require("sprite");
--wat

Door = {};
Door_mt = { __index = Door };

local doors = {};

function Door:new(posX, posY, active)
	local newInstance = sprite.Sprite:new(posX, posY, love.graphics.newImage("content/door.png"), 64, 32)
	setmetatable(newInstance, Door_mt);
	newInstance.body = love.physics.newBody(world, posX + 16, posY, "static");
	newInstance.shape = love.physics.newRectangleShape(32, 64);
	newInstance.fixture = love.physics.newFixture(newInstance.body, newInstance.shape, 0.7);
	newInstance.body:setFixedRotation(true);
	newInstance.active = active or true;
	newInstance.maxY = maxY or 0;
	newInstance.minY = minY or 0;
	setmetatable(Door, { __index = sprite.Sprite });
	table.insert(doors, newInstance);
end

function Door:update(dt)

	if self.active == true then
		if self.fixture:isSensor() then
			self.fixture:setSensor(false);
		end
	else
		if self.fixture:isSensor() == false then
			self.fixture:setSensor(true);
		end
	end
end

function Door:draw()
	if self.active then
		love.graphics.draw(self.canvas, self.body:getX() - 16, self.body:getY() - 32);
	end
end

function Door:trigger()
	self.active = not self.active;
	sound.playSound(2, 0.4);
end

function updateAll(dt)
	for i,v in ipairs(doors) do
		v:update();
	end
end

function drawAll()
	for i,v in ipairs(doors) do
		v:draw();
	end
end

function getByIndex(i)
	return doors[i];
end