module("elevator", package.seeall)
require("sprite");
--wat

Elevator = {};
Elevator_mt = { __index = Elevator };

local elevators = {};

function Elevator:new(posX, posY, minY, maxY, active, goingUp)
	local newInstance = sprite.Sprite:new(posX, posY, love.graphics.newImage("content/elevator.png"), 64, 32)
	setmetatable(newInstance, Elevator_mt);
	newInstance.body = love.physics.newBody(world, posX + 32, posY + 24, "kinematic");
	newInstance.shape = love.physics.newRectangleShape(64, 16);
	newInstance.fixture = love.physics.newFixture(newInstance.body, newInstance.shape, 0.7);
	newInstance.body:setFixedRotation(true);
	newInstance.goingUp = goingUp or false;
	newInstance.active = active or true;
	newInstance.maxY = maxY or 0;
	newInstance.minY = minY or 0;
	setmetatable(Elevator, { __index = sprite.Sprite });
	table.insert(elevators, newInstance);
end

function Elevator:update(dt)
	if self.active == true then
		if self.goingUp == true then
			self.body:setLinearVelocity(0,-64);
		else
			self.body:setLinearVelocity(0, 64);
		end
		if self.body:getY() < self.minY then
			self.goingUp = false;
		elseif self.body:getY() > self.maxY then
			self.goingUp = true;
		end
	else
		self.body:setLinearVelocity(0,0);
	end
end

function Elevator:draw()
	love.graphics.draw(self.canvas, self.body:getX() -  32, self.body:getY() - 24);
end

function Elevator:trigger()
	self.active = not self.active;
end

function updateAll(dt)
	for i,v in ipairs(elevators) do
		v:update();
	end
end

function drawAll()
	for i,v in ipairs(elevators) do
		v:draw();
	end
end

function getByIndex(i)
	return elevators[i];
end