module("player", package.seeall);
require("sprite");
require("input");

player = {};

player.previousSpeedY = 0;

function init()
	player = sprite.Sprite:new(100, 100, love.graphics.newImage("content/player.png"), 80, 80, 3, 3, 0.4);	
	player.body = love.physics.newBody(world, player.posX + player.frameWidth/2, player.posY + player.frameHeight/2, "dynamic");
	player.shape = love.physics.newRectangleShape(player.frameWidth/2 - 20, player.frameHeight - 20)
	player.fixture = love.physics.newFixture(player.body, player.shape, 0.7);
	player.fixture:setUserData("player");
	player.body:setFixedRotation(true);
end

function update()

	--Updates player
	player.posX = player.body:getX()-40;
	player.posY = player.body:getY()-40;
	local sx,sy = plr.player.body:getLinearVelocity();
	
	--Movement Input
	if input.isDown("left") == true then
		player.body:applyForce(-400, 0);
	end
	if input.isDown("right") == true then
		player.body:applyForce(400, 0);
	end
	if input.isDown("jump") then
		if (sy == player.previousSpeedY) then
			player.body:applyLinearImpulse(0, -550);
			sound.playSound(3);
		end
	end
	
	--Animation Control
	if sx > 0.2 then
		player.currentLayer = 0;
	elseif sx < -0.2 then
		player.currentLayer = 1;
	else
		player.currentLayer = 2;
	end
	
	player.previousSpeedY = sy;
	
	player:update();
end

function draw()
	player:draw();
end