module("pressurePlate", package.seeall)
require("sprite");
--wat

PressurePlate = {};
PressurePlate_mt = { __index = PressurePlate };

local pressurePlates = {};

function PressurePlate:new(posX, posY, targetObject, triggerOnce)
	local newInstance = sprite.Sprite:new(posX, posY, love.graphics.newImage("content/pressure_plate.png"), 64, 32)
	setmetatable(newInstance, PressurePlate_mt);
	newInstance.body = love.physics.newBody(world, posX + 32, posY + 28, "static");
	newInstance.shape = love.physics.newRectangleShape(48, 8);
	newInstance.fixture = love.physics.newFixture(newInstance.body, newInstance.shape, 0.7);
	newInstance.fixture:setSensor(true);
	newInstance.body:setFixedRotation(true);
	newInstance.targetObject = targetObject;
	newInstance.triggerOnce = triggerOnce;
	newInstance.fixture:setUserData(newInstance);
	newInstance.tag = "pressurePlate";
	setmetatable(PressurePlate, { __index = sprite.Sprite });
	table.insert(pressurePlates, newInstance);
end

function PressurePlate:update(dt)
	if self.active then
		--do nothing
	end
end

function PressurePlate:draw()	
	if self.active then
		love.graphics.draw(self.canvas, self.body:getX() - 32, self.body:getY() - 20);
	else
		love.graphics.draw(self.canvas, self.body:getX() - 32, self.body:getY() - 24);
	end
end

function PressurePlate:onCollide(fixture)
	if fixture:getUserData() == "player" then
		self.targetObject:trigger();
		self.active = not self.active;
		sound.playSound(1);
	end
end

function PressurePlate:onLeaveCollide(fixture)
	if fixture:getUserData() == "player" then
		if self.triggerOnce == false then
			self.active = not self.active;
			self.targetObject:trigger();
		end
	end
end

function updateAll(dt)
	for i,v in ipairs(pressurePlates) do
		v:update();
	end
end

function drawAll()
	for i,v in ipairs(pressurePlates) do
		v:draw();
	end
end