module("sound", package.seeall);

local sounds = {};
local song = {};

function loadSounds()
	sounds[1] = love.audio.newSource("content/audio/switch.ogg", "static");
	sounds[2] = love.audio.newSource("content/audio/door.ogg", "static");
	sounds[3] = love.audio.newSource("content/audio/jump.ogg", "static");
end

function loadSong(i)
	if i == 1 then
		song = love.audio.newSource("content/audio/song_velvet.ogg");
		song:setLooping(true);
	end
end

function playSound(i, volume)
	love.audio.setPosition(plr.player.body:getX(), plr.player.body:getY(), 0);
	sounds[i]:setPosition(plr.player.body:getX(), plr.player.body:getY(), 0);
	sounds[i]:setVolume(volume or 1.0);
	sounds[i]:play();
end

function playSoundAtObject(i, object)
	love.audio.setPosition(plr.player.body:getX(), plr.player.body:getY(), 0);
	sounds[i]:setPosition(object.body:getX(), object.body:getY(), 0);
	sounds[i]:play();
end

function playMusic(i)
	loadSong(i);
	song:play();
end